# coding:utf-8
# 使用协程作业
import logging
import re
import sys
from urlparse import urlparse

from BeautifulSoup import BeautifulSoup

from httphand import httphand

reload(sys)
sys.setdefaultencoding('utf8')


def getlog(info):
    logger = logging.getLogger()
    hdlr = logging.FileHandler(info['logfile'])
    formatter = logging.Formatter('%(asctime)s %(levelname)s %(message)s')
    hdlr.setFormatter(formatter)
    logger.addHandler(hdlr)
    logger.setLevel(info['loglevel'])
    return logger


def getaurl(url):  # 采集页面上所有的url，以及此次访问的状态码
    tmp = {'url': url, 'response': 404, 'title': ''}
    urls = {}
    xsdanx = httphand()
    result = xsdanx.geturl(url)
    if result is not None:
        sop = BeautifulSoup(result['data'])
        urls = sop.findAll("a", {'href': True})
        tmp['response'] = result['response']
        if sop.head.title is not None:
            tmp['title'] = sop.head.title.string.split(' - ')[0]
        tmp['time'] = sop.body.find('span', {"id": "pubtime_baidu"}).contents[0]
        tmp['source'] = sop.body.find('span', {"id": "source_baidu"}).find('a', {"target": "_blank"}).contents[0]
        tmp['author'] = sop.body.find('span', {"id": "author_baidu"}).find('strong').contents[0]
        tmp['editor'] = sop.body.find('span', {"id": "editor_baidu"}).find('strong').contents[0]
        if sop.body.find('div', {"class": "hot_tags"}) is not None:
            tmp['keywords'] = sop.body.find('div', {"class": "hot_tags"}).find('span').find('a').contents
        tmp['comments'], tmp['comments_count'] = getcomments(result['comments'])
        pass
    return tmp, urls


def getcomments(commentsStr):
    sop = BeautifulSoup(commentsStr)
    comments = sop.findAll('li', {"class": "entry"})
    commentList = []
    count = 0
    for comment in comments:
        commentdict = {}
        commentdict['floor'] = str(comment.find('strong', {"class": "p_floor"}).contents[0])
        commentdict['id'] = str(comment.find('a').get('title')[10:])
        commentdict['nickname'] = str(
            comment.find('strong', {"class": "nick"}).find('a', {"target": "_blank"}).contents[0])
        if comment.find('span').find('a', {"target": "_blank"}) is not None:
            commentdict['mobile'] = str(comment.find('span').find('a', {"target": "_blank"}).contents[0])
        commentdict['address'] = str(comment.find('span', {"class": "posandtime"}).contents[0].split('&nbsp;')[0])
        commentdict['time'] = str(comment.find('span', {"class": "posandtime"}).contents[0].split('&nbsp;')[1])
        commentdict['content'] = str(comment.find('div', {"class": "comm"}).find('p').contents[0])
        commentdict['support'] = int(comment.find('a', {"class": "s"}).contents[0].split('(')[1].split(')')[0])
        commentdict['oppose'] = int(comment.find('a', {"class": "a"}).contents[0].split('(')[1].split(')')[0])
        replys = comment.findAll('li', {"class": "gh"})
        if len(replys) > 0:
            replyList = []
            for reply in replys:
                replydict = {}
                replydict['floor'] = str(reply.find('strong', {"class": "p_floor"}).contents[0])
                replydict['id'] = str(reply.find('a').get('title')[10:])
                replydict['nickname'] = str(
                    reply.find('strong', {"class": "nick"}).find('a', {"target": "_blank"}).contents[0])
                if reply.find('span').find('a', {"target": "_blank"}) is not None:
                    replydict['mobile'] = str(reply.find('span').find('a', {"target": "_blank"}).contents[0])
                replydict['address'] = str(reply.find('span', {"class": "posandtime"}).contents[0].split('&nbsp;')[0])
                replydict['time'] = str(reply.find('span', {"class": "posandtime"}).contents[0].split('&nbsp;')[1])
                replydict['content'] = str(reply.find('div', {"class": "re_comm"}).find('p').contents[0])
                replydict['support'] = int(reply.find('a', {"class": "s"}).contents[0].split('(')[1].split(')')[0])
                replydict['oppose'] = int(reply.find('a', {"class": "a"}).contents[0].split('(')[1].split(')')[0])
                replyList.append(replydict)
                count = count + 1
            commentdict['replys'] = replyList
        commentList.append(commentdict)
        count = count + 1
    return commentList, count


def allstar(info, db):
    thetest, urls = getaurl(info['url'])
    if len(thetest) > 0:
        db.updateone(thetest)
    if urls is not None and len(urls) > 0:
        urlsget(urls, db)


def checkurl(text):  # 检查url
    valid = re.compile("^https.*$")
    if valid.match(text) is None:
        return False
    elif 'www.ithome.com/html' not in text:
        return False
    else:
        return True


def urlsget(urls, db):  # 将爬去到的url入库
    ttmp = set([])
    for i in urls:
        tmp2 = urlparse(i['href'])
        url = tmp2.scheme + "://" + tmp2.netloc + tmp2.path
        if checkurl(url):
            if url not in ttmp:
                db.insertone(url)
                ttmp.add(url)
